<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/wasmparser-0.57.0/src/tests.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>tests.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../wasmparser/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../wasmparser/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../wasmparser/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
</pre><pre class="rust"><code><span class="comment">/* Copyright 2017 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the &quot;License&quot;);
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */</span>

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">test</span>)]</span>
<span class="kw">mod</span> <span class="ident">simple_tests</span> {
    <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::parser</span>::{<span class="ident">Parser</span>, <span class="ident">ParserInput</span>, <span class="ident">ParserState</span>, <span class="ident">WasmDecoder</span>};
    <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::primitives</span>::{<span class="ident">Operator</span>, <span class="ident">SectionCode</span>};
    <span class="kw">use</span> <span class="ident">std::fs::File</span>;
    <span class="kw">use</span> <span class="ident">std::io::prelude</span>::<span class="kw-2">*</span>;
    <span class="kw">use</span> <span class="ident">std::path::PathBuf</span>;

    <span class="kw">fn</span> <span class="ident">read_file_data</span>(<span class="ident">path</span>: <span class="kw-2">&amp;</span><span class="ident">PathBuf</span>) -&gt; <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">u8</span><span class="op">&gt;</span> {
        <span class="macro">println!</span>(<span class="string">&quot;Parsing {:?}&quot;</span>, <span class="ident">path</span>);
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">data</span> <span class="op">=</span> <span class="ident">Vec::new</span>();
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">f</span> <span class="op">=</span> <span class="ident">File::open</span>(<span class="ident">path</span>).<span class="ident">ok</span>().<span class="ident">unwrap</span>();
        <span class="ident">f</span>.<span class="ident">read_to_end</span>(<span class="kw-2">&amp;mut</span> <span class="ident">data</span>).<span class="ident">unwrap</span>();
        <span class="ident">data</span>
    }

    <span class="macro">macro_rules!</span> <span class="ident">expect_state</span> {
        (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">state</span>:<span class="ident">expr</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">expected</span>:<span class="ident">pat</span>) =&gt; {{
            {
                <span class="kw">let</span> <span class="ident">state</span>: <span class="kw-2">&amp;</span><span class="ident">ParserState</span> <span class="op">=</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">state</span>;
                <span class="kw">match</span> <span class="kw-2">*</span><span class="ident">state</span> {
                    <span class="macro-nonterminal">$</span><span class="macro-nonterminal">expected</span> =&gt; (),
                    <span class="kw">_</span> =&gt; <span class="macro">panic!</span>(<span class="string">&quot;Unexpected state during testing: {:?}&quot;</span>, <span class="ident">state</span>),
                }
            }
        }};
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">default_read</span>() {
        <span class="kw">let</span> <span class="ident">data</span> <span class="op">=</span> <span class="ident">read_file_data</span>(<span class="kw-2">&amp;</span><span class="ident">PathBuf::from</span>(<span class="string">&quot;../../tests/local/simple.wasm&quot;</span>));
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">parser</span> <span class="op">=</span> <span class="ident">Parser::new</span>(<span class="ident">data</span>.<span class="ident">as_slice</span>());

        <span class="macro">expect_state!</span>(<span class="ident">parser</span>.<span class="ident">read</span>(), <span class="ident">ParserState::BeginWasm</span> { .. });
        <span class="macro">expect_state!</span>(<span class="ident">parser</span>.<span class="ident">read</span>(), <span class="ident">ParserState::BeginSection</span> { <span class="ident">code</span>: <span class="ident">SectionCode::Type</span>, .. });
        <span class="macro">expect_state!</span>(<span class="ident">parser</span>.<span class="ident">read</span>(), <span class="ident">ParserState::TypeSectionEntry</span>(<span class="kw">_</span>));
        <span class="macro">expect_state!</span>(<span class="ident">parser</span>.<span class="ident">read</span>(), <span class="ident">ParserState::EndSection</span>);
        <span class="macro">expect_state!</span>(<span class="ident">parser</span>.<span class="ident">read</span>(), <span class="ident">ParserState::BeginSection</span> { <span class="ident">code</span>: <span class="ident">SectionCode::Function</span>, .. });
        <span class="macro">expect_state!</span>(<span class="ident">parser</span>.<span class="ident">read</span>(), <span class="ident">ParserState::FunctionSectionEntry</span>(<span class="kw">_</span>));
        <span class="macro">expect_state!</span>(<span class="ident">parser</span>.<span class="ident">read</span>(), <span class="ident">ParserState::EndSection</span>);
        <span class="macro">expect_state!</span>(<span class="ident">parser</span>.<span class="ident">read</span>(), <span class="ident">ParserState::BeginSection</span> { <span class="ident">code</span>: <span class="ident">SectionCode::Code</span>, .. });
        <span class="macro">expect_state!</span>(<span class="ident">parser</span>.<span class="ident">read</span>(), <span class="ident">ParserState::BeginFunctionBody</span> { .. });
        <span class="macro">expect_state!</span>(<span class="ident">parser</span>.<span class="ident">read</span>(), <span class="ident">ParserState::FunctionBodyLocals</span> { .. });
        <span class="macro">expect_state!</span>(<span class="ident">parser</span>.<span class="ident">read</span>(), <span class="ident">ParserState::CodeOperator</span>(<span class="kw">_</span>));
        <span class="macro">expect_state!</span>(<span class="ident">parser</span>.<span class="ident">read</span>(), <span class="ident">ParserState::CodeOperator</span>(<span class="ident">Operator::End</span>));
        <span class="macro">expect_state!</span>(<span class="ident">parser</span>.<span class="ident">read</span>(), <span class="ident">ParserState::EndFunctionBody</span>);
        <span class="macro">expect_state!</span>(<span class="ident">parser</span>.<span class="ident">read</span>(), <span class="ident">ParserState::EndSection</span>);
        <span class="macro">expect_state!</span>(<span class="ident">parser</span>.<span class="ident">read</span>(), <span class="ident">ParserState::EndWasm</span>);
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">default_read_with_input</span>() {
        <span class="kw">let</span> <span class="ident">data</span> <span class="op">=</span> <span class="ident">read_file_data</span>(<span class="kw-2">&amp;</span><span class="ident">PathBuf::from</span>(<span class="string">&quot;../../tests/local/simple.wasm&quot;</span>));
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">parser</span> <span class="op">=</span> <span class="ident">Parser::new</span>(<span class="ident">data</span>.<span class="ident">as_slice</span>());

        <span class="macro">expect_state!</span>(<span class="ident">parser</span>.<span class="ident">read</span>(), <span class="ident">ParserState::BeginWasm</span> { .. });
        <span class="macro">expect_state!</span>(<span class="ident">parser</span>.<span class="ident">read_with_input</span>(<span class="ident">ParserInput::Default</span>),
            <span class="ident">ParserState::BeginSection</span> { <span class="ident">code</span>: <span class="ident">SectionCode::Type</span>, .. });
        <span class="macro">expect_state!</span>(<span class="ident">parser</span>.<span class="ident">read</span>(), <span class="ident">ParserState::TypeSectionEntry</span>(<span class="kw">_</span>));
        <span class="macro">expect_state!</span>(<span class="ident">parser</span>.<span class="ident">read</span>(), <span class="ident">ParserState::EndSection</span>);
        <span class="macro">expect_state!</span>(<span class="ident">parser</span>.<span class="ident">read</span>(), <span class="ident">ParserState::BeginSection</span> { <span class="ident">code</span>: <span class="ident">SectionCode::Function</span>, ..});
        <span class="macro">expect_state!</span>(
            <span class="ident">parser</span>.<span class="ident">read_with_input</span>(<span class="ident">ParserInput::ReadSectionRawData</span>),
            <span class="ident">ParserState::SectionRawData</span>(<span class="kw">_</span>)
        );
        <span class="macro">expect_state!</span>(<span class="ident">parser</span>.<span class="ident">read</span>(), <span class="ident">ParserState::EndSection</span>);
        <span class="macro">expect_state!</span>(<span class="ident">parser</span>.<span class="ident">read</span>(), <span class="ident">ParserState::BeginSection</span> { <span class="ident">code</span>: <span class="ident">SectionCode::Code</span>, .. });
        <span class="macro">expect_state!</span>(<span class="ident">parser</span>.<span class="ident">read</span>(), <span class="ident">ParserState::BeginFunctionBody</span> { .. });
        <span class="macro">expect_state!</span>(
            <span class="ident">parser</span>.<span class="ident">read_with_input</span>(<span class="ident">ParserInput::SkipFunctionBody</span>),
            <span class="ident">ParserState::EndSection</span>
        );
        <span class="macro">expect_state!</span>(<span class="ident">parser</span>.<span class="ident">read</span>(), <span class="ident">ParserState::EndWasm</span>);
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">skipping</span>() {
        <span class="kw">let</span> <span class="ident">data</span> <span class="op">=</span> <span class="ident">read_file_data</span>(<span class="kw-2">&amp;</span><span class="ident">PathBuf::from</span>(<span class="string">&quot;../../tests/local/naming.wasm&quot;</span>));
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">parser</span> <span class="op">=</span> <span class="ident">Parser::new</span>(<span class="ident">data</span>.<span class="ident">as_slice</span>());

        <span class="macro">expect_state!</span>(<span class="ident">parser</span>.<span class="ident">read</span>(),
            <span class="ident">ParserState::BeginWasm</span> { .. });
        <span class="macro">expect_state!</span>(<span class="ident">parser</span>.<span class="ident">read_with_input</span>(<span class="ident">ParserInput::Default</span>),
            <span class="ident">ParserState::BeginSection</span> { <span class="ident">code</span>: <span class="ident">SectionCode::Type</span>, .. });
        <span class="macro">expect_state!</span>(<span class="ident">parser</span>.<span class="ident">read_with_input</span>(<span class="ident">ParserInput::SkipSection</span>),
            <span class="ident">ParserState::BeginSection</span> { <span class="ident">code</span>: <span class="ident">SectionCode::Import</span>, ..});
        <span class="macro">expect_state!</span>(<span class="ident">parser</span>.<span class="ident">read_with_input</span>(<span class="ident">ParserInput::SkipSection</span>),
            <span class="ident">ParserState::BeginSection</span> { <span class="ident">code</span>: <span class="ident">SectionCode::Function</span>, ..});
        <span class="macro">expect_state!</span>(<span class="ident">parser</span>.<span class="ident">read_with_input</span>(<span class="ident">ParserInput::SkipSection</span>),
            <span class="ident">ParserState::BeginSection</span> { <span class="ident">code</span>: <span class="ident">SectionCode::Global</span>, ..});
        <span class="macro">expect_state!</span>(<span class="ident">parser</span>.<span class="ident">read_with_input</span>(<span class="ident">ParserInput::SkipSection</span>),
            <span class="ident">ParserState::BeginSection</span> { <span class="ident">code</span>: <span class="ident">SectionCode::Export</span>, ..});
        <span class="macro">expect_state!</span>(<span class="ident">parser</span>.<span class="ident">read_with_input</span>(<span class="ident">ParserInput::SkipSection</span>),
            <span class="ident">ParserState::BeginSection</span> { <span class="ident">code</span>: <span class="ident">SectionCode::Element</span>, ..});
        <span class="macro">expect_state!</span>(<span class="ident">parser</span>.<span class="ident">read_with_input</span>(<span class="ident">ParserInput::SkipSection</span>),
            <span class="ident">ParserState::BeginSection</span> { <span class="ident">code</span>: <span class="ident">SectionCode::Code</span>, .. });
        <span class="macro">expect_state!</span>(<span class="ident">parser</span>.<span class="ident">read</span>(),
            <span class="ident">ParserState::BeginFunctionBody</span> { .. });
        <span class="macro">expect_state!</span>(<span class="ident">parser</span>.<span class="ident">read_with_input</span>(<span class="ident">ParserInput::SkipFunctionBody</span>),
            <span class="ident">ParserState::BeginFunctionBody</span> { .. });
        <span class="macro">expect_state!</span>(<span class="ident">parser</span>.<span class="ident">read_with_input</span>(<span class="ident">ParserInput::SkipFunctionBody</span>),
            <span class="ident">ParserState::BeginFunctionBody</span> { .. });
        <span class="macro">expect_state!</span>(<span class="ident">parser</span>.<span class="ident">read_with_input</span>(<span class="ident">ParserInput::SkipFunctionBody</span>),
            <span class="ident">ParserState::BeginFunctionBody</span> { .. });
        <span class="macro">expect_state!</span>(<span class="ident">parser</span>.<span class="ident">read_with_input</span>(<span class="ident">ParserInput::SkipFunctionBody</span>),
            <span class="ident">ParserState::BeginFunctionBody</span> { .. });
        <span class="macro">expect_state!</span>(<span class="ident">parser</span>.<span class="ident">read_with_input</span>(<span class="ident">ParserInput::SkipFunctionBody</span>),
            <span class="ident">ParserState::BeginFunctionBody</span> { .. });
        <span class="macro">expect_state!</span>(<span class="ident">parser</span>.<span class="ident">read_with_input</span>(<span class="ident">ParserInput::SkipFunctionBody</span>),
            <span class="ident">ParserState::BeginFunctionBody</span> { .. });
        <span class="macro">expect_state!</span>(
            <span class="ident">parser</span>.<span class="ident">read_with_input</span>(<span class="ident">ParserInput::SkipFunctionBody</span>),
            <span class="ident">ParserState::EndSection</span>
        );
        <span class="macro">expect_state!</span>(<span class="ident">parser</span>.<span class="ident">read</span>(),
            <span class="ident">ParserState::BeginSection</span> { <span class="ident">code</span>: <span class="ident">SectionCode::Custom</span> { .. }, ..});
        <span class="macro">expect_state!</span>(<span class="ident">parser</span>.<span class="ident">read_with_input</span>(<span class="ident">ParserInput::SkipSection</span>),
            <span class="ident">ParserState::BeginSection</span> { <span class="ident">code</span>: <span class="ident">SectionCode::Custom</span> { .. }, .. });
        <span class="macro">expect_state!</span>(
            <span class="ident">parser</span>.<span class="ident">read_with_input</span>(<span class="ident">ParserInput::SkipSection</span>),
            <span class="ident">ParserState::EndWasm</span>
        );
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="wasmparser" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>